package infinispan.test;

import java.io.IOException;

import org.infinispan.Cache;
import org.infinispan.manager.DefaultCacheManager;

public class RunLoadTest {

	public static Cache<Integer, MyObject> testCache;
	public static final int THREADS_AMOUNT = 60; 
	public static final int TRANSACTIONS_PER_THREAD = 100_000;	
	private DefaultCacheManager cm;
	
	public static void main(String[] args) {
		LogUtils.info(RunLoadTest.class, "Starting process");
		RunLoadTest runLoadTest = new RunLoadTest();
		switch (args[0]) {
		case "active":
			runLoadTest.runActiveNode();
			break;

		case "passive":
			runLoadTest.runPassiveNode();
			break;
			
		default:
			LogUtils.error(RunLoadTest.class, "Usge: java RunLoadTest [active/passive]");
			break;

		}
	}

	// Initialize cache
	public RunLoadTest() {		
		try {
			cm = new DefaultCacheManager("/opt/allot/conf/infispan.xml");
			testCache = cm.getCache("testCache");

		} catch (IOException e) {
			// TODO Auto-generated catch block
			LogUtils.error(getClass(), "Failed to initialize cache - "+e);
		}

	}

	private void runPassiveNode() {
		LogUtils.info(getClass(), "Running as passive node...");
		try {
			Thread.sleep(1000000000);
		} catch (InterruptedException e) {
			LogUtils.error(getClass(), e.toString());			
		}
	}

	private void runActiveNode() {
		LogUtils.info(getClass(), "Running as active node...");

		// create {THREADS_AMOUNT} threads and start them.
		for (Integer threadIndex = 0 ; threadIndex < THREADS_AMOUNT ; threadIndex++) {
			LogUtils.info(getClass(), "Starting thread number " + threadIndex);
			Transaction trans = new Transaction(threadIndex);
			Thread thread = new Thread(trans);
			thread.start(); // TODO: Use threadPoolExecutor here
		}				
		
	}	
}
