package infinispan.test;

import java.util.Calendar;
import java.util.concurrent.atomic.AtomicInteger;

public class Transaction implements Runnable {
	Integer threadIndex;
	public static AtomicInteger doneThreadsAmount = new AtomicInteger(0);
	public static final float PRINT_PROGRESS_PERCENTAGE = 0.25f; // Print log messages every X% of thread's progress.

	public Transaction(Integer threadIndex) {
		this.threadIndex = threadIndex;
	}

	@Override
	public void run() {		
		double averageTime = 0;
		double transactionsInOneMillisecond = 0;
		Calendar cal = Calendar.getInstance();
		long run_time =  cal.getTimeInMillis();		
		
		Integer transStartIndex = threadIndex * RunLoadTest.TRANSACTIONS_PER_THREAD;
		Integer transEndIndex = transStartIndex + RunLoadTest.TRANSACTIONS_PER_THREAD;

		for (Integer index = transStartIndex ; index < transEndIndex ; index++) {
			startTransaction(index);
			if ((index + 1 - transStartIndex) % (RunLoadTest.TRANSACTIONS_PER_THREAD * PRINT_PROGRESS_PERCENTAGE) == 0) {
				LogUtils.info(getClass(), "finished "+(100*(index + 1 - transStartIndex)/RunLoadTest.TRANSACTIONS_PER_THREAD)+"% of the thread's transactions");
			}
		}		
		
		// Is this the last finished thread ?
		if (doneThreadsAmount.incrementAndGet() == RunLoadTest.THREADS_AMOUNT) {
			// Calculate how much time this thread was running.
			run_time = Calendar.getInstance().getTimeInMillis() - run_time;
			Integer totalTransactions = (RunLoadTest.TRANSACTIONS_PER_THREAD * RunLoadTest.THREADS_AMOUNT);
			LogUtils.info(getClass(), RunLoadTest.THREADS_AMOUNT +" threads run " + RunLoadTest.TRANSACTIONS_PER_THREAD + " transactions per thread => total of " + totalTransactions + " transactions." );
			LogUtils.info(getClass(), "Run time is " + run_time + " milliseconds.");
			if (run_time != 0) {
				averageTime = run_time / totalTransactions;
				transactionsInOneMillisecond = totalTransactions / run_time;
			}
			LogUtils.info(getClass(), "Average transaction time is " + averageTime);
			LogUtils.info(getClass(), "Amount of transactions in one millisecond is " + transactionsInOneMillisecond);
		}
		
	}

	private void startTransaction(Integer index) {
		MyObject myObject = MyObjectFactory.getMyObject();
		if (index == 0) {
			LogUtils.info(getClass(), "myObject is " + myObject.toString());
		}
		RunLoadTest.testCache.get(index);
		RunLoadTest.testCache.get(index);
//		RunLoadTest.testCache.putAsync(index, myObject);
		RunLoadTest.testCache.put(index, myObject);  //sync !
		RunLoadTest.testCache.get(index);
		RunLoadTest.testCache.get(index);
		RunLoadTest.testCache.get(index);
		RunLoadTest.testCache.get(index);
//		RunLoadTest.testCache.removeAsync(index);
		RunLoadTest.testCache.remove(index);  // sync !
		RunLoadTest.testCache.get(index);
		RunLoadTest.testCache.get(index);
		RunLoadTest.testCache.get(index);
		RunLoadTest.testCache.get(index);
	}

}
